//+------------------------------------------------------------------+
//|                                             Dynamic Zone RSI.mq4 |
//|                                   Copyright  2005, Pavel Kulko. |
//|                                                  polk@alba.dp.ua |
//+------------------------------------------------------------------+
//mod
#property copyright "Copyright  2005, Pavel Kulko"
#property link      "polk@alba.dp.ua"
#property indicator_buffers 1
#property indicator_color1 Lime
//#property indicator_color2 SlateBlue
//#property indicator_color3 Orange

#property indicator_separate_window
#property indicator_level1      1
#property indicator_level2     -1
#property indicator_levelcolor DarkSlateGray

extern int RSIPeriod = 14;
extern int BandPeriod = 20;

double dzRSI[],RSIBuf[],UpZone[],DnZone[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(4); 
   SetIndexStyle(0,DRAW_LINE);
//   SetIndexStyle(1,DRAW_LINE);
//   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(0,dzRSI);
   SetIndexBuffer(3,RSIBuf);
   SetIndexBuffer(1,UpZone);
   SetIndexBuffer(2,DnZone);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double MA, RSI[];
   ArrayResize(RSI,BandPeriod);
   int counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars-1;
   for(int i=limit; i>=0; i--)
   {
      RSIBuf[i] = iRSI(NULL,0,RSIPeriod,PRICE_WEIGHTED,i)-50;
      MA = 0;
      for(int j=i; j<i+BandPeriod; j++) {
         RSI[j-i] = RSIBuf[j];
         MA += RSIBuf[j]/BandPeriod;
      }
      UpZone[i] = MA + (1.3185 * StDev(RSI,BandPeriod));
      DnZone[i] = MA - (1.3185 * StDev(RSI,BandPeriod));  
   
   if(UpZone[i]-DnZone[i]!=0)
   dzRSI[i]=2*((RSIBuf[i]-DnZone[i])/(UpZone[i]-DnZone[i])-0.5);

   }
   
//----
   return(0);
  }
  
double StDev(double& Data[], int Per)
{
  return(MathSqrt(Variance(Data,Per)));
}

double Variance(double& Data[], int Per)
{
  double sum, ssum;
  for (int i=0; i<Per; i++)
  {
    sum += Data[i];
    ssum += MathPow(Data[i],2);
  }
  return((ssum*Per - sum*sum)/(Per*(Per-1)));
}
//+------------------------------------------------------------------+